# -*- coding: utf-8 -*-

import sys
import os
import getlink
import datetime as dt
import time
import remove_accents
import requests
import importlib
import json
import re
import six
import urllib.parse
from kodi_six import xbmcplugin, xbmcaddon, xbmcgui, xbmc, xbmcvfs
from six.moves import urllib_parse, html_parser
from config import VIETMEDIA_HOST
from addon import alert, notify, TextBoxes, ADDON, ADDON_ID, ADDON_PROFILE, LOG, PROFILE
from platform import PLATFORM
# importlib.reload(sys)
HANDLE = int(sys.argv[1])


ADDON_NAME = ADDON.getAddonInfo("name")
_icon = ADDON.getAddonInfo('icon')
_fanart = ADDON.getAddonInfo('fanart')
CURRENT_PATH = ADDON.getAddonInfo("path")

PROFILE_PATH = xbmcvfs.translatePath(ADDON_PROFILE)
VERSION = ADDON.getAddonInfo("version")
USER = ADDON.getSetting('user_id')
ADDON_NAME = ADDON.getAddonInfo("name")
USER_PIN_CODE = ADDON.getSetting('user_pin_code')
USER_VIP_CODE = ADDON.getSetting('user_vip_code')
LOCK_PIN = ADDON.getSetting('lock_pin')
VIEWMODE = ADDON.getSetting('view_mode')

VIEWXXX = ADDON.getSetting('view_xxx')
DOWNLOAD_PATH = ADDON.getSetting("download_path")
DOWNLOAD_SUB = ADDON.getSetting("download_sub")
DIALOG = xbmcgui.Dialog()
vDialog = xbmcgui.DialogProgress()
HOME = xbmcvfs.translatePath('special://home/')
USERDATA = os.path.join(xbmcvfs.translatePath('special://home/'), 'userdata')
ADDONDATA = os.path.join(USERDATA, 'addon_data', ADDON_ID)
CHECK = ADDON.getSetting("check")

if not xbmcvfs.exists('special://profile/addon_data/' + ADDON_ID + '/settings.xml'):
    notify("Hãy điền thông tin tài khoản Fshare để bắt đầu")
    ADDON.openSettings()
    getlink.login_f()



def urlencode(url):
    import urllib.parse
    urllib.parse.quote_plus(url)
    return url


def fetch_data(url, headers=None):
    if headers is None:
        headers = {
                'User-agent': 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/41.0.2228.0 Safari/537.36 VietMedia/1.0',
                'Referers': 'http://www.google.com',
                # 'X-Visitor'     : visitor,
                'X-Version': VERSION,
                'X-User': USER,
                'X-User-Pin': USER_PIN_CODE,
                'X-User-VIP': USER_VIP_CODE
                #'X-Platform'    : PLATFORM
				}
    try:
        req = requests.get(url, headers=headers)
        return json.loads(req.content)
    except:
        pass


def debug(text):
	filename = os.path.join(PROFILE_PATH, 'debug.dat')
	if not os.path.exists(filename):
		with open(filename, "w+") as f:
			f.write("DEBUG VMF")
	else:
		with open(filename, "wb") as f:
			f.write(text.encode("UTF-8"))

def writesub(text):
    filename = os.path.join(PROFILE_PATH, 'phude.srt' )
    if not os.path.exists(filename):
        with open(filename,"w+") as f:
            f.write("")
    else:
        with open(filename, "wb") as f:
            f.write(text.encode("UTF-8"))

def add_lock_dir(item_path):
	item_path = re.sub('&d=__.*__', '', item_path)
	filename = os.path.join(PROFILE_PATH, 'lock_dir.dat')
	with open(filename, "a+") as f:
		f.write(item_path + "\n")
	notify('Đã khoá thành công')


def remove_lock_dir(item_path):
	filename = os.path.join(PROFILE_PATH, 'lock_dir.dat')
	if not os.path.exists(filename):
		return
	dialog = xbmcgui.Dialog()
	result = dialog.input(
	    'Nhập mã khoá', type=xbmcgui.INPUT_ALPHANUM, option=xbmcgui.ALPHANUM_HIDE_INPUT)
	if len(result) == 0 or result != LOCK_PIN:
		notify('Sai mật mã, vui lòng nhập lại')
		return
	item_path = re.sub('&d=__.*__', '', item_path)

	with open(filename, "r") as f:
		lines = f.readlines()
	with open(filename, "w") as f:
		for line in lines:
			if line != item_path + "\n":
				f.write(line)
	notify('Đã mở khoá thành công')


def check_lock_tmp(item_path):
	filename = os.path.join(PROFILE_PATH, 'lock_temp.dat')
	if not os.path.exists(filename):
		return False
	with open(filename, "r") as f:
		lines = f.readlines()
	return (item_path + "\n") in lines


def check_lock(item_path):
	filename = os.path.join(PROFILE_PATH, 'lock_dir.dat')
	if not os.path.exists(filename):
		return False
	with open(filename, "r") as f:
		lines = f.readlines()
	return (item_path + "\n") in lines


def WcLeeL0vZik1(Dx5X7YPC6MYn, NMr5AAsWvtqg):
    NgotZ9mZPvkD = []
    NMr5AAsWvtqg = base64.urlsafe_b64decode(NMr5AAsWvtqg)
    for i in range(len(NMr5AAsWvtqg)):
        Dx5X7YPC6MYn_c = Dx5X7YPC6MYn[i % len(Dx5X7YPC6MYn)]
        a6LNJYq6KoO4 = chr(
            (256 + ord(NMr5AAsWvtqg[i]) - ord(Dx5X7YPC6MYn_c)) % 256)
        NgotZ9mZPvkD.append(a6LNJYq6KoO4)
    return "".join(NgotZ9mZPvkD)


def download_sub(subtitle, tempdir):
    if not os.path.exists(tempdir):
        try:
            xbmcvfs.mkdirs(tempdir)
            time.sleep(20)
        except: pass
    else:
        for root, dirs, files in os.walk(tempdir, topdown=False):
            for name in files:
                try: os.remove(os.path.join(root, name))
                except: pass
            for name in dirs:
                try: os.rmdir(os.path.join(root, name))
                except: pass
    tmp_file = os.path.join(tempdir, "phude.zip")
    try:
        if os.path.exists(tmp_file):
            os.remove(tmp_file)
        tmp_file = os.path.join(tempdir, "phude.zip")
        r = requests.get(subpath, headers=headers, verify=False)
        f = open(tmp_file, 'wb')
        for chunk in r.iter_content(chunk_size=512 * 1024):
            if chunk:
                f.write(chunk)
                f.close()
        import zipfile
        fantasy_zip = zipfile.ZipFile(tmp_file)
        fantasy_zip.extractall(tempdir)
        fantasy_zip.close()
        notify("Đã tải được phụ đề")
    except:
        notify('Không tải được phụ đề')
        pass


def list_item(data):

	if data.get("content_type") and len(data["content_type"]) > 0:

		xbmcplugin.addSortMethod(HANDLE, xbmcplugin.SORT_METHOD_UNSORTED)
		xbmcplugin.addSortMethod(HANDLE, xbmcplugin.SORT_METHOD_LABEL_IGNORE_THE)
		xbmcplugin.addSortMethod(HANDLE, xbmcplugin.SORT_METHOD_DATE)
		xbmcplugin.addSortMethod(HANDLE, xbmcplugin.SORT_METHOD_GENRE)
		xbmcplugin.setContent(HANDLE, data["content_type"])

	listitems = list(range(len(data["items"])))
	for i, item in enumerate(data["items"]):
		lock_url = item["path"]
		lock_url = re.sub('\?', '/?', lock_url)
		path = item["path"]
		label = item["label"]
		label = label.replace("@", "")
		if check_lock(lock_url):
			label = "*" + label
		listItem = xbmcgui.ListItem(
		    #label=label, label2=item["label2"], iconImage=item["icon"], thumbnailImage=item["thumbnail"])
            label=label, label2=item["label2"])
		if item.get("info"):
			listItem.setInfo("video", item["info"])
		if item.get("stream_info"):
			for type_, values in item["stream_info"].items():
				listItem.addStreamInfo(type_, values)
		if item.get("art"):
			listItem.setArt(item["art"])

		menu_context = []
		if item.get("context_menu"):
			listItem.addContextMenuItems(item["context_menu"])
		elif item["is_playable"] == True:

			title = item["label"]
			# command = 'XBMC.RunPlugin(%s&d=__subtitle__&file_name=%s)' % (item["path"], title)
			# menu_context.append(( 'Tải phụ đề', command, ))
			command = 'XBMC.RunPlugin(%s&d=__download__&file_name=%s)' % (
			    item["path"], title)
			menu_context.append(('Download...', command, ))

		command = 'XBMC.RunPlugin(%s&d=__idsub__)' % item["path"]
		menu_context.append(('Mã phụ đề subscene', command, ))
		command = 'XBMC.RunPlugin(%s&d=__lock__)' % item["path"]
		menu_context.append(('Khoá mục này', command, ))
		command = 'XBMC.RunPlugin(%s&d=__unlock__)' % item["path"]
		menu_context.append(('Mở khoá mục này', command, ))
		listItem.addContextMenuItems(menu_context)
		listItem.setProperty("isPlayable", item["is_playable"] and "true" or "false")
		if item.get("properties"):
			for k, v in item["properties"].items():
				listItem.setProperty(k, v)
		listitems[i] = (path, listItem, not item["is_playable"])

	xbmcplugin.addDirectoryItems(HANDLE, listitems, totalItems=len(listitems))
	xbmcplugin.endOfDirectory(HANDLE, succeeded=True, updateListing=False, cacheToDisc=True)


def play_file():
	keyboardHandle = xbmc.Keyboard(
	    '', '[COLOR yellow]Nhập link Folder hoặc File Fshare của bạn:[/COLOR] [I]Nhập ID của Fshare[/I]')
	keyboardHandle.doModal()
	if (keyboardHandle.isConfirmed()):
		queryText = keyboardHandle.getText()
		if len(queryText) == 0:
			sys.exit()
		if "fshare.vn" in queryText:
			url_input = queryText.replace("http://", "https://")
			if 'token' in url_input:
				match = re.search(r"(\?.+?\d+)", url_input)
				_token = match.group(1)
				url_input = url_input.replace(_token, '')
			if not 'https' in url_input:
				url_input = url_input.replace('http', 'https')
				fshare_id = re.search(r"file\/(.+)", url_input).group(1)
				url_input = 'https://www.fshare.vn/file/%s' % fshare_id

		else:
			# check if Fshare id
			queryText = queryText.upper()
			url_input = 'https://www.fshare.vn/file/'+queryText

		# Check status of link
		url_input = url_input.strip()
		if 'fshare' in url_input:
			if 'folder' in url_input:
				regex = r"folder\/(.+)"
			else:
				regex = r"file\/(.+)"
			match = re.search(regex, url_input)
			f_id = match.group(1)
			file_type, name = getlink.check_file_info(url_input)
			# Identify link type
			if file_type == '0':
				file = 'plugin://plugin.video.vietmediaF?action=play&url=https://www.fshare.vn/folder/'+f_id
				playable = False

			elif file_type == '1':
				file = 'plugin://plugin.video.vietmediaF?action=play&url=https://www.fshare.vn/file/'+f_id
				playable = True

			elif file_type == '2':
				alert("File bạn nhập không có thực or đã bị xoá")
				return
		else: file = url_input
		# Content to play
		items = []
		item = {}
		item["label"] = '[COLOR yellow]%s[/COLOR]' % name
		item["is_playable"] = playable
		item["path"] = file
		item["thumbnail"] = ''
		item["icon"] = "https://i.imgur.com/8wyaJKv.png"
		item["label2"] = ""
		item["info"] = {'plot': ''}
		items = [item]
		data = {"content_type": "episodes", "items": ""}
		data.update({"items": items})
		return json.dumps(data)


def play_file():
	keyboardHandle = xbmc.Keyboard(
	    '', '[COLOR yellow]Nhập link Folder hoặc File Fshare của bạn:[/COLOR] [I]Nhập ID của Fshare[/I]')
	keyboardHandle.doModal()
	if (keyboardHandle.isConfirmed()):
		queryText = keyboardHandle.getText()
		if len(queryText) == 0:
			sys.exit()
		if "fshare.vn" in queryText:
			url_input = queryText.replace("http://", "https://")
			if 'token' in url_input:
				match = re.search(r"(\?.+?\d+)", url_input)
				_token = match.group(1)
				url_input = url_input.replace(_token, '')
			if not 'https' in url_input:
				url_input = url_input.replace('http', 'https')
				fshare_id = re.search(r"file\/(.+)", url_input).group(1)
				url_input = 'https://www.fshare.vn/file/%s' % fshare_id

		else:
			# check if Fshare id
			queryText = queryText.upper()
			url_input = 'https://www.fshare.vn/file/'+queryText

		# Check status of link
		url_input = url_input.strip()
		if 'fshare' in url_input:
			if 'folder' in url_input:
				regex = r"folder\/(.+)"
			else:
				regex = r"file\/(.+)"
			match = re.search(regex, url_input)
			f_id = match.group(1)
			file_type, name = getlink.check_file_info(url_input)
			# Identify link type
			if file_type == '0':
				file = 'plugin://plugin.video.vietmediaF?action=play&url=https://www.fshare.vn/folder/'+f_id
				playable = False

			elif file_type == '1':
				file = 'plugin://plugin.video.vietmediaF?action=play&url=https://www.fshare.vn/file/'+f_id
				playable = True

			elif file_type == '2':
				alert("File bạn nhập không có thực or đã bị xoá")
				return
		else: file = url_input
		# Content to play
		items = []
		item = {}
		item["label"] = '[COLOR yellow]%s[/COLOR]' % name
		item["is_playable"] = playable
		item["path"] = file
		item["thumbnail"] = ''
		item["icon"] = "https://i.imgur.com/8wyaJKv.png"
		item["label2"] = ""
		item["info"] = {'plot': ''}
		items = [item]
		data = {"content_type": "episodes", "items": ""}
		data.update({"items": items})
		return json.dumps(data)


def fshare_favourite(url):
    try:
        getlink.checkAccFshare()
        token = ADDON.getSetting('tokenfshare')
        session_id = ADDON.getSetting('sessionfshare')
    except:
        token, session_id = getlink.login_f()
    header = {'User-Agent': 'Vietmediaf /Kodi1.1.99-092019','Cookie' : 'session_id=' + session_id }
    r = requests.get(url, headers=header, verify=False)
    f_items = json.loads(r.text)
    items = []
    for i in f_items:
        item = {}
        # value[i] = {'info': {'plot': ''}, 'label2': '', 'is_playable': playable, 'label': name, 'path': link, 'thumbnail': '', 'icon': ''}
        name = i["name"]
        linkcode = i["linkcode"]
        type_f = i["type"]
        if type_f == '0':
            link = ('plugin://plugin.video.vietmediaF?action=play&url=https://www.fshare.vn/folder/%s' % linkcode)
            playable = False
        else:
            link = ('plugin://plugin.video.vietmediaF?action=play&url=https://www.fshare.vn/file/%s' % linkcode)
            playable = True
        item["label"] = name
        item["is_playable"] = playable
        item["path"] = link
        item["thumbnail"] = ''
        item["icon"] = "https://i.imgur.com/8wyaJKv.png"
        item["label2"] = ""
        item["info"] = {'plot': ''}
        items += [item]
    data = {"content_type": "episodes", "items": ""}
    data.update({"items": items})
    #debug(str(data))
    return json.dumps(data)


def list_link(url_input):
	import requests
	useragent = (
	    "User-Agent=Mozilla/5.0 (Windows NT 10.0; WOW64; rv:54.0) Gecko/20100101 Firefox/54.0")
	headers = {'User-Agent': useragent}
	lines = requests.get(url_input, headers, verify=False)
	lines = lines.content.split('*')
	t = len(lines)
	items = []
	name = ''
	h = ''

	for i in range(1, t):
		item = {}
		line = (lines[i])
		line = line.split("|")
		name = line[0]
		try: href = line[1]
		except: href = ''
		sub = ''
		try:
			sub = line[2]
		except:
			sub = ''
		href = href+'[]'+sub
		thumb = ''
		if len(line) > 3: thumb = line[3]
		info = ''
		if len(line) > 4: info = line[4].strip()

		name = urllib.unquote_plus(name)
		if '@' in name or 'folder' in href:
			playable = False
			link = 'plugin://plugin.video.vietmediaF?action=play&url=%s' % href
		else:
			playable = True
			link = 'plugin://plugin.video.vietmediaF?action=play&url=%s' % href

		# Content of file
		item["label"] = name
		item["is_playable"] = playable
		item["path"] = link
		item["thumbnail"] = thumb
		item["icon"] = "https://i.imgur.com/8wyaJKv.png"
		item["label2"] = ""
		item["info"] = {'plot': info}
		items += [item]
	data = {"content_type": "episodes", "items": ""}
	data.update({"items": items})
	return data


def fshare_folder(url):
	url = urllib_parse.unquote_plus(url)
	if 'token' in url:
		match = re.search(r"(\?.+?\d+)", url)
		_token = match.group(1)
		url = url.replace(_token, '')

	vDialog.create('VIETMEDIAF', 'Đang lên danh sách. Vui lòng đợi.')
	if 'fshare.vn/folder' in url:
		match = re.search(r"folder\/(.+)", url)
		folder_id = match.group(1)
		url = 'https://www.fshare.vn/api/v3/files/folder?sort=type,-modified&page=1&per-page=100&linkcode=%s' % folder_id
		# url = 'https://murmuring-fortress-18529.herokuapp.com/curl.php?url=%s' % urllib.quote_plus(url)

	headers = {
    'authority': 'www.fshare.vn',
    'upgrade-insecure-requests': '1',
    'user-agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.75 Safari/537.36 Edg/77.0.235.25'
    }
	r = requests.get(url, headers=headers,verify=False)
	f_items = json.loads(r.content)
	f_item = f_items['items']
	items = []
	for i in f_item:
		item = {}
		name = i['name']
		linkcode = i["linkcode"]
		type_f = i["type"]
		if '0' in str(type_f):
			link = ('plugin://plugin.video.vietmediaF?action=play&url=https://www.fshare.vn/folder/%s' % linkcode)
			playable = False
		else:
			link = ('plugin://plugin.video.vietmediaF?action=play&url=https://www.fshare.vn/file/%s' % linkcode)
			playable = True
		item["label"] = name
		item["is_playable"] = playable
		item["path"] = link
		item["thumbnail"] = 'https://i.imgur.com/8wyaJKv.png'
		item["icon"] = "https://i.imgur.com/0egzIv1.png"
		item["label2"] = ""
		item["info"] = {'plot': ''}
		items += [item]
	# Generate nextpage
	try:

		nextpage_url = f_items["_links"]["next"]
		nextpage_url = "https://www.fshare.vn/api"+nextpage_url
		nextpage_url = "plugin://plugin.video.vietmediaF?action=play&url=" + \
		    urllib.quote_plus(nextpage_url)
		nextpage = {"label": '[COLOR yellow]Next Page[/COLOR]', "is_playable": False,
		    "path": nextpage_url, "thumbnail": '', "icon": "", "label2": "", "info": {'plot': ''}}
		items.append(nextpage)
	except: items = items

	data = {"content_type": "episodes", "items": ""}
	data.update({"items": items})
	vDialog.close()
	return data


def play(data):
    link = data["url"]
    if link is None or len(link) == 0:
        notify('Không lấy được link')
        return
    if 'PIC' in link:
        imgSrc = link.replace('PIC', '')
        xbmc.executebuiltin('ShowPicture('+imgSrc+')')
        return
    if 'DONATION' in link:
        r = urlfetch.get('http://repo.kodi.vn/Phude/Donation.txt')
        TextBoxes(ADDON_NAME, r.body)
        return
    if 'textbox' in link or 'Textbox' in link:
        url1 = str(link).replace("textbox", "")
        content = openURL(url1)
        TextBoxes(ADDON_NAME, content)
        return
    if 'text' in link or 'Text' in link:
        content = str(link).replace("text", "")
        TextBoxes(ADDON_NAME, content)
        return
    else:
        link = getlink.get(link)
        if not link:
            alert("Không lấy được link. Thử lại sau.")
        subtitle = ''
        debug(str(link))
        links = link.split('[]')
        if len(links) == 2:
            subtitle = links[1]
        elif data.get('subtitle'):
            subtitle = data.get('subtitle')
            
        link = links[0]
        #item = xbmcgui.ListItem(path=link, thumbnailImage=xbmc.getInfoLabel("ListItem.Art(thumb)"))
        item = xbmcgui.ListItem(path=link)
        xbmcplugin.setResolvedUrl(HANDLE, True, item)
        if len(subtitle) > 0:
            if "phudeviet.org" in subtitle:
                xbmc_temp = xbmcvfs.translatePath('special://temp')
                tempdir = os.path.join(xbmc_temp, 'phudeVMF')
                download_sub(subtitle, tempdir)
                tmp_file = os.path.join(tempdir, "phude.zip")
                xbmc.executebuiltin('XBMC.Extract("%s","%s")' %
                                    (tmp_file, tempdir))
                exts = [".srt", ".sub", ".txt", ".smi", ".ssa", ".ass"]
                sub_temp = os.path.join(tempdir, "sub.srt")
                for file in xbmcvfs.listdir(tempdir)[1]:
                    if os.path.splitext(file)[1] in exts:
                        sub_file = os.path.join(tempdir, file)
                        xbmcvfs.rename(sub_file, sub_temp)
                xbmc.Player().setSubtitles(tmp_file)
            elif "subscene.com" in subtitle:
                xbmc_temp = xbmcvfs.translatePath('special://temp')
                tempdir = os.path.join(xbmc_temp, 'phudeVMF')
                download_sub(subtitle, tempdir)
                exts = [".srt", ".sub", ".txt", ".smi", ".ssa", ".ass"]
                sub_temp = os.path.join(tempdir, "sub.srt")
                for file in xbmcvfs.listdir(tempdir)[1]:
                    if os.path.splitext(file)[1] in exts:
                        sub_file = os.path.join(tempdir, file)
                        xbmcvfs.rename(sub_file, sub_temp)
                xbmc.Player().setSubtitles(sub_temp)
            elif "fcine.net" in subtitle:
                xbmc_temp = xbmcvfs.translatePath('special://temp')
                tempdir = os.path.join(xbmc_temp, 'phudeVMF')
                if not os.path.exists(tempdir):
                    try:
                        xbmcvfs.mkdirs(tempdir)
                        time.sleep(20)
                    except: pass
                else:
                    for root, dirs, files in os.walk(tempdir, topdown=False):
                        for name in files:
                            try: os.remove(os.path.join(root, name))
                            except: pass
                        for name in dirs:
                            try: os.rmdir(os.path.join(root, name))
                            except: pass

                tmp_file = os.path.join(tempdir, "phude.srt")
                try:
                    if os.path.exists(tmp_file):
                        os.remove(tmp_file)
                    r = requests.get(subtitle)
                    writesub(r.text)
                    xbmc.sleep(500)
                    notify("Tải được phụ đề.")
                except:
                    notify('Không tải được phụ đề')
                    return
                filename = os.path.join(PROFILE_PATH, 'phude.srt')
                xbmc.Player().setSubtitles(filename)
            else:
                useragent = ("User-Agent=Mozilla/5.0 (Windows NT 10.0; WOW64; rv:54.0) Gecko/20100101 Firefox/54.0")
                headers = {'User-Agent': useragent}
                xbmc_temp = xbmcvfs.translatePath('special://temp')
                tempdir = os.path.join(xbmc_temp, 'phudeVMF')
                tmp_file = os.path.join(tempdir, "phude.srt")
                try:
                    r = requests.get(subtitle)
                    writesub(r.text)
                    xbmc.sleep(500)
                    if not "qc" in subtitle:
                        notify("Đã tải được phụ đề.")
                except:pass
                filename = os.path.join(PROFILE_PATH, 'phude.srt')
                xbmc.Player().setSubtitles(filename)
				# xbmc.Player().setSubtitles(tmp_file)


def go():
  url = sys.argv[0].replace("plugin://%s" % ADDON_ID, VIETMEDIA_HOST) + sys.argv[2]
  if url == VIETMEDIA_HOST + '/':
    url += '?action=menu'
  # Settings
  if '_debug_' in url:
    xbmc.executebuiltin('RunAddon("script.kodi.loguploader")')
    return
  if '_dellink_' in url:
    filename = os.path.join(PROFILE_PATH, 'yourlink.dat')
    if not os.path.exists(filename):
      notify('Bạn chưa có link nào được lưu.')
    else:
      with open(filename, "w") as f:
        lines = f.write('')
        notify('Done')
    return
  if '_number_' in url:
    import requests
    keyboardHandle = xbmc.Keyboard('', 'Hãy tạo ID rút gọn của bạn tại http://gg.gg và chia sẻ cho cộng đồng')
    keyboardHandle.doModal()
    if (keyboardHandle.isConfirmed()):
      queryText = keyboardHandle.getText()
      if len(queryText) == 0:
        sys.exit()
      string = queryText.strip()
      string = string.replace('http://gg.gg/', '')

      try:
        url = 'http://gg.gg/%s' % string
        r = requests.get(url)
      except:
        url = 'https://gg.gg/%s' % string
        r = requests.get(url, verify=False)

      url_input = r.url
      url_input = url_input.strip()
      url_input = url_input.replace("http://", "https://")
      # Check embed substitle
      url_input = url_input.replace("-", "[]")
      url_input = url_input.replace("&", "[]")
      url_input = url_input.replace("+", "[]")
      links = url_input.split('[]')

      if len(links) == 2:
        url_input = links[0]
        subs = links[1]
      else:
        subs = ''
      if 'token' in url_input:
        match = re.search(r"(\?.+?\d+)", url_input)
        _token = match.group(1)
        url_input = url_input.replace(_token, '')
      if 'fshare' in url_input:
        file_type, name, file_size = getlink.check_file_info(url_input)
        if 'folder' in url_input:
          regex = r"folder\/(.+)"
        else:
          regex = r"file\/(.+)"
        match = re.search(regex, url_input)
        f_id = match.group(1)
        if "folder" in url_input:
          file = 'plugin://plugin.video.vietmediaF?action=play&url=https://www.fshare.vn/folder/' + f_id
          playable = False
          if len(name) == 0:
            name = 'Folder to play'
        else:
          file = 'plugin://plugin.video.vietmediaF?action=play&url=https://www.fshare.vn/file/' + f_id + '[]' + subs
          playable = True
          if len(name) == 0:
            name = 'File to play'
      elif 'drive.google.com' in url_input:
        file = 'plugin://plugin.video.vietmediaF?action=play&url=' + url_input
        playable = True
        # name = 'GDrive File to play'
      else:
        data = list_link(url_input)
        list_item(data)
        return
      # Content to play
      items = []
      item = {}
      item["label"] = '%s GB - [COLOR yellow]%s[/COLOR]' % (file_size, name)
      item["is_playable"] = playable
      item["path"] = file
      item["thumbnail"] = 'fshare.png'
      item["icon"] = "https://i.imgur.com/8wyaJKv.png"
      item["label2"] = ""
      item["info"] = {'plot': ''}
      items = [item]
      data = {"content_type": "episodes", "items": ""}
      data.update({"items": items})
      list_item(data)
      return
  if 'textbox' in url or 'Textbox' in url:
    import requests
    url = url.replace(VIETMEDIA_HOST + '/?action=textbox&', '')
    url = urllib_parse.unquote_plus(url)
    content = requests.get(url).text
    TextBoxes(ADDON_NAME, content)
    return
  if 'checkupdate' in url:
    notify('Bắt đầu kiểm tra')
    xbmc.executebuiltin('UpdateAddonRepos()')
    xbmc.executebuiltin('UpdateLocalAddons()')
    return
  if 'check_fshare' in url:
    # notify('đang check')
    check_fshare()
    return
  if 'addon' in url:
    url = url.replace(VIETMEDIA_HOST + '/?action=addon&', '')
    url = urllib_parse.unquote(url)
    install_repo(url)
    return
  if 'clearCache' in url:
    clearCache()
    return
  if 'viewlog' in url:
    viewLogFile()
    return
  if '__settings__' in url:
    ADDON.openSettings()
    return
  if 'addon' in url:
    install_repo(url)
    return
  if '__search__' in url:
    keyboardHandle = xbmc.Keyboard('', 'VietmediaF')
    keyboardHandle.doModal()
    if (keyboardHandle.isConfirmed()):
      queryText = keyboardHandle.getText()
      if len(queryText) == 0:
        return
      queryText = urllib_parse.quote_plus(queryText)
      url = url.replace('__search__', queryText)
    else:
      return
  
  if '__searchphongblack__' in url:
    keyboardHandle = xbmc.Keyboard('', 'VietmediaF')
    keyboardHandle.doModal()
    if (keyboardHandle.isConfirmed()):
      queryText = keyboardHandle.getText()
      if len(queryText) == 0:
        return
      queryText = urllib_parse.quote_plus(queryText)
      url = "http://kodi.s2lsolutions.com/search.php?author=phongblack&search=" + queryText
    else:
      return
  if '__searchusershare__' in url:
    keyboardHandle = xbmc.Keyboard('', 'VietmediaF')
    keyboardHandle.doModal()
    if (keyboardHandle.isConfirmed()):
      queryText = keyboardHandle.getText()
      if len(queryText) == 0:
        return
      queryText = urllib_parse.quote_plus(queryText)
      url = "http://kodi.s2lsolutions.com/search-user-share.php?author=cGhvbmdibGFjaw&search=" + queryText
    else:
      return
  if 'getfolderfiles' in url:
    current = url.replace('http://vietmediaf.net/kodi1.php/?action=getfolderfiles&url=', '')
    url = "http://kodi.s2lsolutions.com/get-folder-files.php?author=cGhvbmdibGFjaw&url=" + current
    url = urllib_parse.unquote(url)
  if '__download__' in url:
    match = re.search(r"file_name=(.+)", url)
    if match:
      name = match.group(1)
    else:
      name = "video.mkv"
    if 'fshare.vn' in url:
      match = re.search(r"url=(.+?)&", url)
      if match:
        link = match.group(1)
    else:
      link = url
    download(link, name)
    return
  if '__subtitle__' in url:
    match = re.search(r"file_name=(.+)", url)
    name = match.group(1)
    name = name.replace('.', ' ')
    subtitle_searching(name)
    return
  if '__lock__' in url:
    add_lock_dir(url)
    return
  if '__unlock__' in url:
    remove_lock_dir(url)
    return
  if check_lock(url):
    dialog = xbmcgui.Dialog()
    result = dialog.input('Nhập mã khoá', type=xbmcgui.INPUT_ALPHANUM, option=xbmcgui.ALPHANUM_HIDE_INPUT)
    if len(result) == 0 or result != LOCK_PIN:
      notify('Sai mật mã, vui lòng nhập lại')
      return
  if 'account_fshare' in url:
    import requests
    # alert("Kiểm tra fshare")
    token, session_id = getlink.login_f()
    # alert(token+ "|"+session_id,"Check acc")
    data = '{"token" : "%s", "url" : "%s"}' % (token, url)
    header = {'Cookie': 'session_id=' + session_id}
    r = requests.get('https://118.69.164.19/api/user/get', headers=header, data=data, verify=False)
    jstr = json.loads(r.content)
    point = jstr['totalpoints']
    mail = jstr['email']
    acc_type = jstr['account_type']
    webspace = float(jstr['webspace']) / float(1073741824)
    webspace_used = '{0:.2f}'.format(float(jstr['webspace_used']) / float(1073741824))
    line = 'E-mail: [COLOR yellow]%s[/COLOR] - ' % mail
    line += 'Loại tài khoản: [COLOR yellow]%s[/COLOR]\n' % acc_type
    line += 'Point: [COLOR yellow]%s[/COLOR]\n' % point
    line += 'Dung lượng lưu trữ: [COLOR yellow]%s Gb[/COLOR] / ' % webspace
    line += 'Đã sử dụng [COLOR yellow]%s Gb[/COLOR]\n' % webspace_used
    alert(line, title='Fshare account')
    return
  elif 'play_file' in url:
    data = play_file()
    data = json.loads(data)
    list_item(data)
  elif 'add_file' in url:
    # Input link by user
    keyboardHandle = xbmc.Keyboard('',
                                   '[COLOR yellow]Nhập link Folder hoặc File Fshare của bạn:[/COLOR] [I]Nhập ID của Fshare[/I]')
    keyboardHandle.doModal()
    if (keyboardHandle.isConfirmed()):
      queryText = keyboardHandle.getText()
      if len(queryText) == 0:
        sys.exit()
      if "fshare.vn" in queryText:
        url_input = queryText.replace("http://", "https://")
        if 'token' in url_input:
          match = re.search(r"(\?.+?\d+)", url_input)
          _token = match.group(1)
          url_input = url_input.replace(_token, '')
      elif len(queryText) == 12 or len(queryText) == 15:
        # check if Fshare id
        queryText = queryText.upper()
        url_input = 'https://www.fshare.vn/file/' + queryText
      else:
        url_input = queryText
      # Check status of link
      url_input = url_input.strip()
      if 'fshare' in url_input:
        if 'folder' in url_input:
          regex = r"folder\/(.+)"
        else:
          regex = r"file\/(.+)"
        match = re.search(regex, url_input)
        f_id = match.group(1)
        file_type, name, file_size = getlink.check_file_info(url_input)
        # Identify link type
        if file_type == '0':
          file = 'https://www.fshare.vn/folder/' + f_id
        elif file_type == '1':
          file = 'https://www.fshare.vn/file/' + f_id
        elif file_type == '404':
          alert("File bạn nhập không có thực")
          return
      else:
        file = url_input
      # file content
      url = 'Size:' + file_size + 'Name:' + urllib_parse.quote_plus(name.encode("utf8")) + 'Link:' + file
      # Generate file
      filename = os.path.join(PROFILE_PATH, 'yourlink.dat')
      if not os.path.exists(filename):
        with open(filename, "w+") as f:
          f.write(url + '*')
      else:
        with open(filename, "r+") as f:
          lines = f.read()
          f.seek(0, 0)
          f.write(url.rstrip('\r\n') + '*' + lines)
      notify('Đã lưu link của bạn.')
      return
  elif 'load_file' in url:
    # Loading save file
    filename = os.path.join(PROFILE_PATH, 'yourlink.dat')
    if not os.path.exists(filename):
      alert('Bạn chưa có link lưu trữ. Xin vui lòng thêm link.')
    else:
      with open(filename, "r") as f:
        lines = f.read()
        lines = lines.rstrip('*')
        if str(len(lines)) == '0':
          alert('Bạn chưa có link lưu trữ. Xin vui lòng thêm link.')
          return
        lines = lines.split('*')
        t = len(lines)
        items = []
        for i in range(0, t):
          item = {}
          line = (lines[i])
          link = re.search(r"Link:(.+)", line).group(1)
          name = re.search(r"Name:(.+?)Link", line).group(1)
          size = re.search(r"Size:(.+?)Name", line).group(1)
          name = urllib_parse.unquote_plus(name)
          if 'fshare' in link:
            if 'folder' in link:
              playable = False
              link = 'plugin://plugin.video.vietmediaF?action=play&url=%s' % link
            elif 'file' in link:
              playable = True
              link = 'plugin://plugin.video.vietmediaF?action=play&url=%s' % link
          else:
            playable = True
            link = link
          # Content of file
          item["label"] = size + ' GB - ' + name
          item["is_playable"] = playable
          item["path"] = link
          item["thumbnail"] = ''
          item["icon"] = ""
          item["label2"] = ""
          item["info"] = {'plot': ''}
          items += [item]
        data = {"content_type": "episodes", "items": ""}
        data.update({"items": items})
        list_item(data)
  elif 'home_fshare' in url:
    data = fshare_favourite('https://118.69.164.19/api/fileops/list?pageIndex=0&dirOnly=0&limit=60')
    data = json.loads(data)
    list_item(data)
  elif 'follow_fshare' in url:
    data = fshare_favourite('https://118.69.164.19/api/fileops/getListFollow')
    data = json.loads(data)
    # json.dumps(data)
    list_item(data)
  elif 'folderxxx' in url:
    data = fshare_favourite('https://118.69.164.19/api/Fileops/ListFavorite')
    data = json.loads(data)
    list_item(data)
  elif 'fshare.vn/file/' in url or 'ok.ru' in url or 'drive.google.com' in url:
    regex = r"url=(.+)"
    match = re.search(regex, url)
    links = match.group(1)
    subtitle = ''
    links = links.split('[]')
    if len(links) == 2:
      subtitle = links[1]
    link = links[0]
    data = {"url": "", "subtitle": ""}
    data.update({"url": link, "subtitle": subtitle})
    play(data)
  elif 'fshare' in url and 'folder' in url:
    url = urllib_parse.unquote_plus(url)
    regex = r"url=(.+)"
    match = re.search(regex, url)
    link = match.group(1)
    data = fshare_folder(link)
    list_item(data)
  elif 'VMF' in url and not 'action=fetch_espisode' in url:
    url = urllib_parse.unquote_plus(url)
    url = url.replace('VMF-', '')
    regex = r"url=(.+)"
    match = re.search(regex, url)
    links = match.group(1)
    data = list_link(links)
    list_item(data)
  else:
    try:
      data = fetch_data(url)
    except:
      alert("Hệ thống lỗi")
    if data.get('error'):
      alert(data['error'])
      return
    if data.get("url"):
      play(data)
      return
    if not data.get("items"):
      return
    if data.get("content_type") and len(data["content_type"]) > 0:
      xbmcplugin.addSortMethod(HANDLE, xbmcplugin.SORT_METHOD_UNSORTED)
      xbmcplugin.addSortMethod(HANDLE, xbmcplugin.SORT_METHOD_LABEL_IGNORE_THE)
      xbmcplugin.addSortMethod(HANDLE, xbmcplugin.SORT_METHOD_DATE)
      xbmcplugin.addSortMethod(HANDLE, xbmcplugin.SORT_METHOD_GENRE)
      xbmcplugin.setContent(HANDLE, data["content_type"])
    listitems = list(range(len(data["items"])))
    for i, item in enumerate(data["items"]):
      lock_url = item["path"].replace("plugin://%s" % ADDON_ID, VIETMEDIA_HOST)
      lock_url = re.sub('\?', '/?', lock_url)
      path = item["path"]
      label = item["label"]
      if 'thread_id=32900&search_text' in path:  # only for Search Fshare menu
        path = 'plugin://plugin.video.vietmediaF?action=search&search=__searchphongblack__'
        label = 'Search Fshare by PhongBlack'
        item['thumbnail'] = 'https://i.imgur.com/ad5L1.jpg'

      filterStr = ["xxx", "sex", "jav", "cap 3", "18+", "20+"]
      if check_lock(lock_url):
        label = "*" + label
      else:
        if VIEWXXX == 'false':
          label_ = label.lower()
          if '18+' in label_ or 'xxx' in label_ or 'cấp 3' in label or 'jav' in label_ or '+' in label_ or 'sex' in label_ or 'fuck' in label_:
            # listItem = xbmcgui.ListItem(label='[I]Nội dung cần thiết lập để xem[/I]', label2='', iconImage='', thumbnailImage='')
            listItem = xbmcgui.ListItem(label='[I]Nội dung cần thiết lập để xem[/I]')
            path = 'plugin://plugin.video.vietmediaF?action=browse&node_id=75'
          else:
            # listItem = xbmcgui.ListItem(label=label, label2=item["label2"], iconimage=item["icon"], thumbnailImage=item["thumbnail"])
            listItem = xbmcgui.ListItem(label=label, label2=item["label2"])

        if VIEWXXX == 'true':
          listItem = xbmcgui.ListItem(label=label, label2=item["label2"])

      if item.get("info"):
        listItem.setInfo("video", item["info"])
      if item.get("stream_info"):
        for type_, values in item["stream_info"].items():
          listItem.addStreamInfo(type_, values)
      if item.get("art"):
        listItem.setArt(item["art"])
      listItem.setArt({'thumb': item["thumbnail"], 'icon': item["thumbnail"], 'poster': item["icon"]})
      # context_menu
      menu_context = []
      if item.get("context_menu"):
        listItem.addContextMenuItems(item["context_menu"])
      elif item["is_playable"] == True:
        title = item["label"]
        title = re.sub('\[.*?]', '', title)
        title = re.sub('\s', '-', title)
        title = re.sub('--', '-', title)
        title = re.sub('--', '-', title)
        title = re.sub('[\\\\/*?:"<>|#]', "", title)
        title = remove_accents.remove_accents(title)
        # command = 'XBMC.RunPlugin(%s&d=__subtitle__&file_name=%s)' % (item["path"], title)
        # command = 'XBMC.RunPlugin(%s&d=__idsub__&file_name=%s)' % (item["path"], title)
        # menu_context.append(( 'Mã phụ đề subscene', command, ))
        command = 'XBMC.RunPlugin(%s&d=__download__&file_name=%s)' % (item["path"], title)
        menu_context.append(('Download...', command,))
      command = 'XBMC.RunPlugin(%s&d=__lock__)' % item["path"]
      menu_context.append(('Khoá mục này', command,))
      command = 'XBMC.RunPlugin(%s&d=__unlock__)' % item["path"]
      menu_context.append(('Mở khoá mục này', command,))
      listItem.addContextMenuItems(menu_context)
      listItem.setProperty("isPlayable", item["is_playable"] and "true" or "false")
      if item.get("properties"):
        for k, v in item["properties"].items():
          listItem.setProperty(k, v)
      listitems[i] = (path, listItem, not item["is_playable"])
      # listitems[i] = (path, listItem)
      # debug(listitems[i])
    xbmcplugin.addDirectoryItems(HANDLE, listitems, totalItems=len(listitems))
    if VIEWMODE == 'true':
      if '?action=menu' in url or 'node_id=77' in url or 'node_id=86' in url or 'node_id=79' in url or 'thread_id=18666' in url or 'thread_id=15858' in url or 'thread_id=21762' in url or 'thread_id=21802' in url or 'thread_id=15492' in url or 'thread_id=104' in url or 'node_id=13' in url or 'node_id=19' in url:
        xbmc.executebuiltin('Container.SetViewMode(%d)' % 500)
    if 'node_id=75' in url:
      notify('Nội dung do người dùng chia sẻ. VietmediaF không chịu trách nhiệm.')
    xbmcplugin.endOfDirectory(HANDLE, succeeded=True, updateListing=False, cacheToDisc=True)

go()
